diff --git a/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
rename to src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
index 9b44e6fc9..8a5c9d853 100644
--- a/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
+++ b/src/main/java/net/minecraft/core/block/FireflyLanternBlock.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -18,14 +18,14 @@ import org.jetbrains.annotations.NotNull;
 import java.util.Random;
 import java.util.function.Supplier;
 
-public class BlockLanternFirefly extends Block{
+public class FireflyLanternBlock extends Block{
 
     public Item item;
     private final Supplier<Item> itemSupplier;
-    private final EntityFireflyCluster.FireflyColor color;
+    private final FireflyClusterMob.FireflyColor color;
 
-    public BlockLanternFirefly(String key, int id, EntityFireflyCluster.FireflyColor colour, @NotNull Supplier<Item> itemSupplier) {
-        super(key, id, Material.glass);
+    public FireflyLanternBlock(String key, String namespaceId, int id, FireflyClusterMob.FireflyColor colour, @NotNull Supplier<Item> itemSupplier) {
+        super(key, namespaceId, id, Material.glass);
         this.color = colour;
         this.itemSupplier = itemSupplier;
         setBlockBounds(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.5f, 1 - 0.3125f);
@@ -42,7 +42,7 @@ public class BlockLanternFirefly extends Block{
         float offset = 0.0F;
         if (metadata == 1)
             offset = 0.3875F;
-        return AABB.getBoundingBoxFromPool(x + 0.3125f, y + offset, z + 0.3125f, x + 1 - 0.3125f, (float) y + 0.5F + offset, z + 1 - 0.3125f);
+        return AABB.getTemporaryBB(x + 0.3125f, y + offset, z + 0.3125f, x + 1 - 0.3125f, (float) y + 0.5F + offset, z + 1 - 0.3125f);
     }
 
     @Override
@@ -70,13 +70,13 @@ public class BlockLanternFirefly extends Block{
     }
 
     @Override
-    public boolean renderAsNormalBlock()
+    public boolean isCubeShaped()
     {
         return false;
     }
 
     @Override
-    public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+    public void animationTick(World world, int x, int y, int z, Random rand)
     {
         if(rand.nextInt(3)==0)
         {
@@ -85,7 +85,7 @@ public class BlockLanternFirefly extends Block{
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
         world.setBlockRaw(x, y, z, 0);
         world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
@@ -97,7 +97,7 @@ public class BlockLanternFirefly extends Block{
         return true;
     }
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
         if ((side == Side.BOTTOM || (side != Side.TOP && sideHeight >= 0.5d)) && (world.isBlockNormalCube(x, y+1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))){
             world.setBlockMetadataWithNotify(x, y, z, 1);
             return;
@@ -133,7 +133,7 @@ public class BlockLanternFirefly extends Block{
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -158,12 +158,12 @@ public class BlockLanternFirefly extends Block{
     }
     
     @Override
-    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, EntityPlayer player, Item item) {
+    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, Player player, Item item) {
     	if(item != null && item.isSilkTouch()) {
     		return;
     	}
     	if(!world.isClientSide) {
-        	EntityFireflyCluster entity = new EntityFireflyCluster(world);
+        	FireflyClusterMob entity = new FireflyClusterMob(world);
         	entity.setColor(color);
         	entity.setFireflyCount(1);
         	entity.setClusterSize(0);
diff --git a/src/main/java/net/minecraft/core/block/BlockFlag.java b/src/main/java/net/minecraft/core/block/FlagBlock.java
similarity index 63%
rename from src/main/java/net/minecraft/core/block/BlockFlag.java
rename to src/main/java/net/minecraft/core/block/FlagBlock.java
index fcbac8b3c..42c29847b 100644
--- a/src/main/java/net/minecraft/core/block/BlockFlag.java
+++ b/src/main/java/net/minecraft/core/block/FlagBlock.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityFlag;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.FlagBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
 
@@ -14,10 +14,10 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockFlag extends BlockTileEntity{
+public class FlagBlock extends EntityBlock {
 
-    public BlockFlag(String key, int id, Material material) {
-        super(key, id, material);
+    public FlagBlock(String key, String namespaceId, int id, Material material) {
+        super(key, namespaceId, id, material);
         float f = 2 / 16f;
         float f1 = 1.0F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f1, 0.5F + f);
@@ -29,7 +29,7 @@ public class BlockFlag extends BlockTileEntity{
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -41,27 +41,27 @@ public class BlockFlag extends BlockTileEntity{
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        ItemStack stack = new ItemStack(Item.flag);
-        if (tileEntity != null)
+        ItemStack stack = new ItemStack(Items.FLAG);
+        if (blockEntity != null)
         {
             CompoundTag compound = new CompoundTag();
-            ((TileEntityFlag) tileEntity).writeFlagNBT(compound);
+            ((FlagBlockEntity) blockEntity).writeFlagNBT(compound);
             stack.getData().putCompound("FlagData", compound);
         }
         return new ItemStack[] { stack };
     }
 
 	@Override
-	public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
+	public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
 		if (!world.isClientSide) {
-			TileEntityFlag flag = (TileEntityFlag) world.getBlockTileEntity(x, y, z);
+			FlagBlockEntity flag = (FlagBlockEntity) world.getBlockEntity(x, y, z);
 			if (flag.owner != null && !flag.owner.isEmpty() && !player.username.equals(flag.owner)) {
 				return false;
 			}
 			int heldItemId = player.getHeldItem() != null ? player.getHeldItem().itemID : 0;
-			if(heldItemId == Item.map.id || heldItemId == Item.flag.id) {
+			if(heldItemId == Items.MAP.id || heldItemId == Items.FLAG.id) {
 				return false;
 			}
 			player.displayGUIEditFlag(flag);
@@ -71,10 +71,10 @@ public class BlockFlag extends BlockTileEntity{
 	}
 
     @Override
-    protected TileEntity getNewBlockEntity() {
+    protected BlockEntity getNewBlockEntity() {
         try
         {
-            return new TileEntityFlag();
+            return new FlagBlockEntity();
         }
         catch(Exception exception)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockFlower.java b/src/main/java/net/minecraft/core/block/FlowerBlock.java
similarity index 84%
rename from src/main/java/net/minecraft/core/block/BlockFlower.java
rename to src/main/java/net/minecraft/core/block/FlowerBlock.java
index 13735f24d..14b31fc1d 100644
--- a/src/main/java/net/minecraft/core/block/BlockFlower.java
+++ b/src/main/java/net/minecraft/core/block/FlowerBlock.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
@@ -15,37 +15,37 @@ import net.minecraft.core.world.WorldSource;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            Block, Material, World, BlockGrass, 
+//            Block, Material, World, GrassBlock,
 //            AxisAlignedBB
 
-public class BlockFlower extends Block implements IBonemealable
+public class FlowerBlock extends Block implements IBonemealable
 {
 
 	public boolean killedByWeather = false;
 	public boolean canBeBonemealed = false;
 
-	public BlockFlower(String key, int id)
+	public FlowerBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.plant);
+        super(key, namespaceId, id, Material.plant);
         setTicking(true);
         float f = 0.2F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 3F, 0.5F + f);
     }
     
-    public BlockFlower setKilledByWeather()
+    public FlowerBlock setKilledByWeather()
     {
     	killedByWeather = true;
     	return this;
     }
-    public BlockFlower setBonemealable()
+    public FlowerBlock setBonemealable()
     {
         canBeBonemealed = true;
         return this;
     }
 
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side placeSide, EntityLiving entity, double sideHeight) {
-        if (entity instanceof EntityPlayer){
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side placeSide, Mob mob, double sideHeight) {
+        if (mob instanceof Player){
             world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | 0b1000_0000); // Set persistent flag
         }
     }
@@ -107,13 +107,13 @@ public class BlockFlower extends Block implements IBonemealable
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         Random rand = world.rand;
         if(!world.isClientSide && canBeBonemealed)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
similarity index 62%
rename from src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
rename to src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
index 0b99fdac4..0eaf1dad1 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
+++ b/src/main/java/net/minecraft/core/block/FloweringCherryLeavesBlock.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -12,37 +12,38 @@ import net.minecraft.core.world.season.Seasons;
 
 import java.util.Random;
 
-public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBonemealable
+public class FloweringCherryLeavesBlock extends CherryLeavesBlock implements IBonemealable
 {
-	public BlockLeavesCherryFlowering(String key, int id) {
-        super(key, id);
+    public static final int MASK_GROWTH_DATA = 0b1111_0000;
+	public FloweringCherryLeavesBlock(String key, String namespaceId, int id) {
+        super(key, namespaceId, id);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        int growthRate = (meta & 0xF0) >> 4;
+        int growthRate = getGrowthRate(meta);
         if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(this) };
 
         if (growthRate == 0) return null;
         else
         {
-            return new ItemStack[] { new ItemStack(Item.foodCherry, world.rand.nextInt(2) + 1) };
+            return new ItemStack[] { new ItemStack(Items.FOOD_CHERRY, world.rand.nextInt(2) + 1) };
         }
     }
 
     @Override
-    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
+    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
         onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        int decayData = meta & 0x0F;
-        int growthRate = (meta & 0xF0) >> 4;
+        int decayData = meta & MASK_DECAY_DATA;
+        int growthRate = getGrowthRate(meta);
         if(growthRate > 0)
         {
             world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
@@ -51,7 +52,7 @@ public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBo
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null);
             }
             world.setBlockMetadataWithNotify(x, y, z, decayData);
-            world.scheduleBlockUpdate(x, y, z, leavesCherryFlowering.id, tickRate());
+            world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
             return true;
         }
         return super.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
@@ -62,24 +63,24 @@ public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBo
 	public void updateTick(World world, int x, int y, int z, Random rand) {
         super.updateTick(world, x, y, z, rand);
         int meta = world.getBlockMetadata(x, y, z);
-        int growthRate = (meta & 0XF0) >> 4;
+        int growthRate = getGrowthRate(meta);
 
         if (world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING) {
             if (rand.nextInt(20) == 0) {
                 if ((growthRate) == 0) {
                     world.setBlockMetadataWithNotify(x, y, z, 1 << 4 | meta);
-                    world.scheduleBlockUpdate(x, y, z, leavesCherryFlowering.id, tickRate());
+                    world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
                 }
             }
         }
        else if(growthRate > 0){
-            world.setBlockMetadataWithNotify(x, y, z, meta & 0X0F);
-            world.scheduleBlockUpdate(x, y, z, leavesCherryFlowering.id, tickRate());
+            world.setBlockMetadataWithNotify(x, y, z, meta & MASK_DECAY_DATA);
+            world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
         }
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
         if(((meta & 0xF0) >> 4) == 0)
         {
@@ -97,4 +98,7 @@ public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBo
         }
         return false;
     }
+    public static int getGrowthRate(int meta){
+        return (meta & MASK_GROWTH_DATA) >> NUM_DECAY_BITS;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java b/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
similarity index 67%
rename from src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
rename to src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
index 0e9c2729a..a1b1642c0 100644
--- a/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
+++ b/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
@@ -9,18 +9,22 @@ import net.minecraft.core.world.World;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFluid, World, Material, WorldProvider, 
+//            FluidBlock, World, Material, WorldProvider,
 //            Block
 
-public class BlockFluidFlowing extends BlockFluid
+public class FlowingFluidBlock extends FluidBlock
 {
+    int maxCount;
+    boolean[] result;
+    int[] distance;
 
-	public BlockFluidFlowing(String key, int id, Material material)
+
+	public FlowingFluidBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
-        numAdjacentSources = 0;
-        isOptimalFlowDirection = new boolean[4];
-        flowCost = new int[4];
+        super(key, namespaceId, id, material);
+        maxCount = 0;
+        result = new boolean[4];
+        distance = new int[4];
     }
 
     private void setFluidStill(World world, int x, int y, int z)
@@ -43,11 +47,11 @@ public class BlockFluidFlowing extends BlockFluid
         if(localFlowDecay > 0)
         {
             int surroundingFlowDecay = -100;
-            numAdjacentSources = 0;
-            surroundingFlowDecay = getSmallestFlowDecay(world, x - 1, y, z, surroundingFlowDecay);
-            surroundingFlowDecay = getSmallestFlowDecay(world, x + 1, y, z, surroundingFlowDecay);
-            surroundingFlowDecay = getSmallestFlowDecay(world, x, y, z - 1, surroundingFlowDecay);
-            surroundingFlowDecay = getSmallestFlowDecay(world, x, y, z + 1, surroundingFlowDecay);
+            maxCount = 0;
+            surroundingFlowDecay = getHighest(world, x - 1, y, z, surroundingFlowDecay);
+            surroundingFlowDecay = getHighest(world, x + 1, y, z, surroundingFlowDecay);
+            surroundingFlowDecay = getHighest(world, x, y, z - 1, surroundingFlowDecay);
+            surroundingFlowDecay = getHighest(world, x, y, z + 1, surroundingFlowDecay);
             int newFlowDecay = surroundingFlowDecay + flowDecayMod;
             if(newFlowDecay >= 8 || surroundingFlowDecay < 0)
             {
@@ -64,7 +68,7 @@ public class BlockFluidFlowing extends BlockFluid
                     newFlowDecay = flowDecayAbove + 8;
                 }
             }
-            if(numAdjacentSources >= 2 && blockMaterial == Material.water)
+            if(maxCount >= 2 && blockMaterial == Material.water)
             {
                 if(world.getBlockMaterial(x, y - 1, z).isSolid())
                 {
@@ -85,7 +89,7 @@ public class BlockFluidFlowing extends BlockFluid
                 else
                 {
                     world.setBlockMetadataWithNotify(x, y, z, localFlowDecay);
-                    world.scheduleBlockUpdate(x, y, z, id, tickRate());
+                    world.scheduleBlockUpdate(x, y, z, id, tickDelay());
                     world.notifyBlocksOfNeighborChange(x, y, z, id);
                 }
             }
@@ -98,7 +102,7 @@ public class BlockFluidFlowing extends BlockFluid
         {
             setFluidStill(world, x, y, z);
         }
-        if(liquidCanDisplaceBlock(world, x, y - 1, z))
+        if(canSpreadTo(world, x, y - 1, z))
         {
         	int id = world.getBlockId(x, y - 1, z);
         	int meta = world.getBlockMetadata(x, y - 1, z);
@@ -112,9 +116,9 @@ public class BlockFluidFlowing extends BlockFluid
                 world.setBlockAndMetadataWithNotify(x, y - 1, z, this.id, localFlowDecay + 8);
             }
         } else
-        if(localFlowDecay >= 0 && (localFlowDecay == 0 || blockBlocksFlow(world, x, y - 1, z)))
+        if(localFlowDecay >= 0 && (localFlowDecay == 0 || isFluidBlocking(world, x, y - 1, z)))
         {
-            boolean aflag[] = getOptimalFlowDirections(world, x, y, z);
+            boolean aflag[] = getSpread(world, x, y, z);
             int k1 = localFlowDecay + flowDecayMod;
             if(localFlowDecay >= 8)
             {
@@ -145,7 +149,7 @@ public class BlockFluidFlowing extends BlockFluid
 
     private void flowIntoBlock(World world, int i, int j, int k, int l)
     {
-        if(liquidCanDisplaceBlock(world, i, j, k))
+        if(canSpreadTo(world, i, j, k))
         {
             int i1 = world.getBlockId(i, j, k);
             if(i1 > 0)
@@ -162,7 +166,7 @@ public class BlockFluidFlowing extends BlockFluid
         }
     }
 
-    private int calculateFlowCost(World world, int i, int j, int k, int l, int i1)
+    private int getSlopeDistance(World world, int x, int y, int z, int l, int i1)
     {
         int j1 = 1000;
         for(int k1 = 0; k1 < 4; k1++)
@@ -171,30 +175,30 @@ public class BlockFluidFlowing extends BlockFluid
             {
                 continue;
             }
-            int l1 = i;
-            int i2 = j;
-            int j2 = k;
+            int x2 = x;
+            int y2 = y;
+            int z2 = z;
             if(k1 == 0)
             {
-                l1--;
+                x2--;
             }
             if(k1 == 1)
             {
-                l1++;
+                x2++;
             }
             if(k1 == 2)
             {
-                j2--;
+                z2--;
             }
             if(k1 == 3)
             {
-                j2++;
+                z2++;
             }
-            if(blockBlocksFlow(world, l1, i2, j2) || world.getBlockMaterial(l1, i2, j2) == blockMaterial && world.getBlockMetadata(l1, i2, j2) == 0)
+            if(isFluidBlocking(world, x2, y2, z2) || world.getBlockMaterial(x2, y2, z2) == blockMaterial && world.getBlockMetadata(x2, y2, z2) == 0)
             {
                 continue;
             }
-            if(!blockBlocksFlow(world, l1, i2 - 1, j2))
+            if(!isFluidBlocking(world, x2, y2 - 1, z2))
             {
                 return l;
             }
@@ -202,7 +206,7 @@ public class BlockFluidFlowing extends BlockFluid
             {
                 continue;
             }
-            int k2 = calculateFlowCost(world, l1, i2, j2, l + 1, k1);
+            int k2 = getSlopeDistance(world, x2, y2, z2, l + 1, k1);
             if(k2 < j1)
             {
                 j1 = k2;
@@ -212,68 +216,68 @@ public class BlockFluidFlowing extends BlockFluid
         return j1;
     }
 
-    private boolean[] getOptimalFlowDirections(World world, int i, int j, int k)
+    private boolean[] getSpread(World world, int x, int y, int z)
     {
         for(int l = 0; l < 4; l++)
         {
-            flowCost[l] = 1000;
-            int j1 = i;
-            int i2 = j;
-            int j2 = k;
+            distance[l] = 1000;
+            int x2 = x;
+            int y2 = y;
+            int z2 = z;
             if(l == 0)
             {
-                j1--;
+                x2--;
             }
             if(l == 1)
             {
-                j1++;
+                x2++;
             }
             if(l == 2)
             {
-                j2--;
+                z2--;
             }
             if(l == 3)
             {
-                j2++;
+                z2++;
             }
-            if(blockBlocksFlow(world, j1, i2, j2) || world.getBlockMaterial(j1, i2, j2) == blockMaterial && world.getBlockMetadata(j1, i2, j2) == 0)
+            if(isFluidBlocking(world, x2, y2, z2) || world.getBlockMaterial(x2, y2, z2) == blockMaterial && world.getBlockMetadata(x2, y2, z2) == 0)
             {
                 continue;
             }
-            if(!blockBlocksFlow(world, j1, i2 - 1, j2))
+            if(!isFluidBlocking(world, x2, y2 - 1, z2))
             {
-                flowCost[l] = 0;
+                distance[l] = 0;
             } else
             {
-                flowCost[l] = calculateFlowCost(world, j1, i2, j2, 1, l);
+                distance[l] = getSlopeDistance(world, x2, y2, z2, 1, l);
             }
         }
 
-        int i1 = flowCost[0];
+        int i1 = distance[0];
         for(int k1 = 1; k1 < 4; k1++)
         {
-            if(flowCost[k1] < i1)
+            if(distance[k1] < i1)
             {
-                i1 = flowCost[k1];
+                i1 = distance[k1];
             }
         }
 
         for(int l1 = 0; l1 < 4; l1++)
         {
-            isOptimalFlowDirection[l1] = flowCost[l1] == i1;
+            result[l1] = distance[l1] == i1;
         }
 
-        return isOptimalFlowDirection;
+        return result;
     }
 
-    private boolean blockBlocksFlow(World world, int x, int y, int z)
+    private boolean isFluidBlocking(World world, int x, int y, int z)
     {
         int id = world.getBlockId(x, y, z);
-        if (Block.blocksList[id] == null || Block.blocksList[id] instanceof BlockFluid || Block.blocksList[id].hasTag(BlockTags.BROKEN_BY_FLUIDS)) return false;
+        if (Block.blocksList[id] == null || Block.blocksList[id] instanceof FluidBlock || Block.blocksList[id].hasTag(BlockTags.BROKEN_BY_FLUIDS)) return false;
         return true;
     }
 
-    protected int getSmallestFlowDecay(World world, int x, int y, int z, int currentFlowDecay)
+    protected int getHighest(World world, int x, int y, int z, int currentFlowDecay)
     {
         int flowDecay = getDepth(world, x, y, z);
         if(flowDecay < 0)
@@ -282,7 +286,7 @@ public class BlockFluidFlowing extends BlockFluid
         }
         if(flowDecay == 0)
         {
-            numAdjacentSources++;
+            maxCount++;
         }
         if(flowDecay >= 8)
         {
@@ -291,7 +295,7 @@ public class BlockFluidFlowing extends BlockFluid
         return currentFlowDecay >= 0 && flowDecay >= currentFlowDecay ? currentFlowDecay : flowDecay;
     }
 
-    private boolean liquidCanDisplaceBlock(World world, int i, int j, int k)
+    private boolean canSpreadTo(World world, int i, int j, int k)
     {
         Material material = world.getBlockMaterial(i, j, k);
         if(material == blockMaterial)
@@ -304,21 +308,17 @@ public class BlockFluidFlowing extends BlockFluid
         }
         else
         {
-            return !blockBlocksFlow(world, i, j, k);
+            return !isFluidBlocking(world, i, j, k);
         }
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
+        super.onBlockPlacedByWorld(world, x, y, z);
         if(world.getBlockId(x, y, z) == id)
         {
-            world.scheduleBlockUpdate(x, y, z, id, tickRate());
+            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
         }
     }
-
-    int numAdjacentSources;
-    boolean isOptimalFlowDirection[];
-    int flowCost[];
 }
